"""
This type stub file was generated by pyright.
"""

"""Decorators to keep function results in an in-memory and database cache"""

class CacheDecorator:
    """Simplified in-memory cache"""
    def __init__(self, func, keyarg) -> None: ...
    def __get__(self, instance, cls):  # -> partial[Any]:
        ...
    def __call__(self, *args, **kwargs): ...
    def update(self, key, value):  # -> None:
        ...
    def invalidate(self, key=...):  # -> None:
        ...

class MemoryCacheDecorator(CacheDecorator):
    """In-memory cache"""
    def __init__(self, func, keyarg, maxage) -> None: ...
    def __call__(self, *args, **kwargs): ...
    def update(self, key, value):  # -> None:
        ...

class DatabaseCacheDecorator:
    """Database cache"""

    db = ...
    _init = ...
    def __init__(self, func, keyarg, maxage) -> None: ...
    def __get__(self, obj, objtype):  # -> partial[Any]:
        ...
    def __call__(self, *args, **kwargs):  # -> Any:
        ...
    def update(self, key, value):  # -> None:
        ...
    def invalidate(self, key):  # -> None:
        ...
    def database(self):  # -> None:
        ...

def memcache(maxage=..., keyarg=...):  # -> Callable[..., MemoryCacheDecorator]:
    ...
def cache(maxage=..., keyarg=...):  # -> Callable[..., DatabaseCacheDecorator]:
    ...
def clear(module):  # -> Literal[0] | None:
    """Delete database entries for 'module'"""
    ...
